from pathlib import Path
from click.testing import CliRunner
from ase.io import read
from ase.build import bulk
from test.file_comparison import compare_geo_files
from clims.cli.mace import clims_prerelax


geometry_in = """\
lattice_vector 6.3424000625000003 0.0000000000000000 0.0000000000000000
lattice_vector 0.0000000000000004 6.3424000625000003 0.0000000000000000
lattice_vector 0.0000000000000004 0.0000000000000004 6.3424000625000003
atom_frac 0.4985070174686732 0.4984753283607610 0.4984391279480256 Pb
atom_frac 0.9947067051243741 0.4985585744497497 0.4985239897502917 I
atom_frac 0.4933691056089859 0.9946781165777344 0.4985067920019748 I
atom_frac 0.4934096948374262 0.4933045519706207 0.9946418980330605 I
atom_frac 0.9636066959707023 0.9685230268852982 0.9735016928627009 C
atom_frac 0.0964661473134567 0.1028459790177419 0.1092681953078861 N
atom_frac 0.8648932142712814 0.8687516830305604 0.0746980652562706 H
atom_frac 0.0669248970527235 0.8708916836401469 0.8748263002291492 H
atom_frac 0.8648877825735546 0.0707791241212009 0.8747967353171048 H
atom_frac 0.1950609531184868 0.0158756953610258 0.2080049998028645 H
atom_frac 0.0084353203397442 0.2005150264439032 0.2079821657812684 H
atom_frac 0.1950536837883362 0.2024919488039628 0.0233524765531140 H
"""
geometry_final = """\
#===============================================================================
# Created using the Atomic Simulation Environment (ASE)

# Thu Sep 12 13:18:20 2024

#=======================================================
lattice_vector 6.3424000625000003 0.0000000000000000 0.0000000000000000
lattice_vector 0.0000000000000004 6.3424000625000003 0.0000000000000000
lattice_vector 0.0000000000000004 0.0000000000000004 6.3424000625000003
atom_frac 0.4985433688732859 0.4985626637408101 0.4985815675341151 Pb
atom_frac 0.9941394644077367 0.4995864671000251 0.4996119054808583 I
atom_frac 0.4941945891424226 0.9943414529170197 0.4992367203254898 I
atom_frac 0.4938628163075001 0.4938365667077100 0.9945575728718498 I
atom_frac 0.9629707482519703 0.9678473293041218 0.9727852546383766 C
atom_frac 0.0975447339343845 0.1038413625213399 0.1101763367903368 N
atom_frac 0.8638386711701220 0.8676944433208577 0.0726498265285400 H
atom_frac 0.0649304008034645 0.8697891370555212 0.8737137145025256 H
atom_frac 0.8638250409019897 0.0687562619565739 0.8737090161413094 H
atom_frac 0.1959923258748914 0.0167351910455958 0.2087727148226604 H
atom_frac 0.0094060744507501 0.2014288472714388 0.2086682043192888 H
atom_frac 0.1960729833492286 0.2032710157216931 0.0240796048883609 H
"""


def test_mace():
    runner = CliRunner()
    with runner.isolated_filesystem():
        with open("geometry.in", "w") as fd:
            fd.write(geometry_in)
        with open("geometry-final.in", "w") as fd:
            fd.write(geometry_final)
        result = runner.invoke(clims_prerelax, "--fmax 0.05")
        assert result.exit_code == 0
        compare_geo_files("geometry.in.next_step.005", "geometry-final.in")
